package com.welchsoftwaredevelopers.myapplication;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class ChoiceActivity extends AppCompatActivity {
    private ArrayList<HashMap<String, List>> script;
    private ArrayList<String> ScriptQuestion;
    private RadioGroup group;
    private SharedPreferences sharedPref;
    private Boolean clear;
    private Boolean fail;
    private Integer current;

    public ChoiceActivity() {
        script = new ArrayList<>();
        fail = false;
    }


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_choice);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        Intent intent = getIntent();
        group = (RadioGroup) findViewById(R.id.radioGroup1);
        ScriptQuestion = intent.getStringArrayListExtra("Questions");
        current = intent.getIntExtra("Next", 0);
        clear = intent.getBooleanExtra("Clear", false);

        Integer i = 0;
        Integer size = intent.getIntExtra("Size", 0);
        ((TextView) findViewById(R.id.question)).setText(ScriptQuestion.get(current));
        while (i < size) {
            HashMap<String, List> tmp1 = new HashMap<>();
            tmp1.putAll((HashMap<String, List>) intent.getSerializableExtra("Opts" + i.toString()));
            script.add(tmp1);
            i++;
        }
        Log.d("D", "script size: " + size.toString());
        Log.d("D", "script: " + script.toString());
        Log.d("D", "current: " + current.toString());
        Log.d("D", "questions: " + ScriptQuestion.toString());
        Iterator iter1 = script.get(current).get("Text").iterator();
        RadioButton button;
        while (iter1.hasNext()) {
            button = new RadioButton(this);
            Log.d("D", "Radiobutton");
            button.setText((String) iter1.next());
            group.addView(button);
        }
    }

    @Override
    protected void onStart() {
        super.onStart();
        Integer Total;
        sharedPref = this.getPreferences(Context.MODE_PRIVATE);
        if (clear) {
            Log.d("D", "clear");
            Total = 0;
            SharedPreferences.Editor editor = sharedPref.edit();
            editor.putInt(getString(R.string.Total), 0);
            if (clear) {
                Clear();
            }
            editor.commit();
        } else {
            Total = sharedPref.getInt(getString(R.string.Total), 0);
        }
        ((TextView) findViewById(R.id.choice_textView_total)).setText(Total.toString());
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.main, menu);
        inflater.inflate(R.menu.choice, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle item selection
        switch (item.getItemId()) {
            case R.id.clearMenu:
                Clear();
                return true;
            case R.id.FailMenu:
                fail = true;
            default:
                return super.onOptionsItemSelected(item);
        }
    }

    public void ClickDone(View v) {
        Integer totalDone;

        totalDone = sharedPref.getInt(getString(R.string.Total), 0);
        Log.d("D", fail.toString());
        if (!fail) {
            totalDone = sharedPref.getInt(getString(R.string.Total), 0) + 1;
            SharedPreferences.Editor editor = sharedPref.edit();
            editor.putInt(getString(R.string.Total), totalDone);
            editor.apply();
        }


        Intent intent = new Intent(this, MainActivity.class);
        intent.putExtra("Clear", clear);
        intent.putExtra(getString(R.string.Total), totalDone);
        intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK);
        clear = false;
        fail = false;
        startActivity(intent);
        finish();
    }

    public void ClickChoice(View v) {
        if (group.getCheckedRadioButtonId() == -1) {
            Toast.makeText(this, "Select an option", Toast.LENGTH_SHORT).show();
        } else {
            Intent intent = new Intent(this, ChoiceActivity.class);
            intent.putStringArrayListExtra("Questions", ScriptQuestion);
            intent.putExtra("Size", script.size());
            intent.putExtra("Clear", clear);
            clear = false;
            fail = false;
            Log.d("D", "Sel button: " + ((Integer) group.indexOfChild(findViewById(group.getCheckedRadioButtonId()))).toString());

            intent.putExtra("Next", (Integer) script.get(current).get("Destination").get(group.indexOfChild(findViewById(group.getCheckedRadioButtonId()))));

            Iterator<HashMap<String, List>> iter1 = script.iterator();
            Integer i = 0;
            while (iter1.hasNext()) {
                String nameOpts = "Opts" + i.toString();
                intent.putExtra(nameOpts, iter1.next());
                i++;
            }
            startActivity(intent);
        }
    }

    public void Clear() {
        clear = true;
        ((TextView) findViewById(R.id.choice_textView_total)).setText("0");

        SharedPreferences.Editor editor = sharedPref.edit();
        editor.putInt(getString(R.string.Total), 0);
        editor.commit();
    }
}
